org.gradle.api.tasks.bundling

## Class War

- java.lang.Object
- - org.gradle.api.internal.AbstractTask
  - - org.gradle.api.DefaultTask
    - - org.gradle.api.internal.ConventionTask
      - - org.gradle.api.tasks.AbstractCopyTask
        - - org.gradle.api.tasks.bundling.AbstractArchiveTask
          - - org.gradle.api.tasks.bundling.Zip
            - - org.gradle.jvm.tasks.Jar
              - - org.gradle.api.tasks.bundling.Jar
                - - org.gradle.api.tasks.bundling.War

- All Implemented Interfaces:
    Comparable<Task>, ContentFilterable, CopyProcessingSpec, CopySourceSpec, CopySpec, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.file.copy.CopySpecSource, org.gradle.api.internal.IConventionAware, org.gradle.api.internal.TaskInternal, ExtensionAware, Task, PatternFilterable, org.gradle.util.Configurable<Task>

      @CacheableTask
      public class War
      extends Jar

  Assembles a WAR archive.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Task

      `Task.Namer`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `WAR_EXTENSION`

    - ### Fields inherited from class org.gradle.jvm.tasks.Jar

      `DEFAULT_EXTENSION`

    - ### Fields inherited from class org.gradle.api.tasks.bundling.Zip

      `ZIP_EXTENSION`

    - ### Fields inherited from interface org.gradle.api.Task

      `TASK_ACTION, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `War()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `classpath(Object... classpath)` Adds files to the classpath to include in the WAR archive.
    `FileCollection` | `getClasspath()` Returns the classpath to include in the WAR archive.
    `CopySpec` | `getWebInf()`
    `File` | `getWebXml()` Returns the `web.xml` file to include in the WAR archive.
    `void` | `setClasspath(Object classpath)` Sets the classpath to include in the WAR archive.
    `void` | `setWebXml(File webXml)` Sets the `web.xml` file to include in the WAR archive.
    `CopySpec` | `webInf(Closure configureClosure)` Adds some content to the `WEB-INF` directory for this WAR archive.

    - ### Methods inherited from class org.gradle.api.tasks.bundling.Jar

      `manifest`

    - ### Methods inherited from class org.gradle.jvm.tasks.Jar

      `getManifest, getManifestContentCharset, getMetadataCharset, getMetaInf, metaInf, setManifest, setManifestContentCharset, setMetadataCharset`

    - ### Methods inherited from class org.gradle.api.tasks.bundling.Zip

      `createCopyAction, getCompressor, getEntryCompression, isZip64, setEntryCompression, setZip64`

    - ### Methods inherited from class org.gradle.api.tasks.bundling.AbstractArchiveTask

      `createCopyActionExecuter, getAppendix, getArchiveName, getArchivePath, getBaseName, getClassifier, getDestinationDir, getExtension, getVersion, into, into, into, isPreserveFileTimestamps, isReproducibleFileOrder, setAppendix, setArchiveName, setBaseName, setClassifier, setDestinationDir, setExtension, setPreserveFileTimestamps, setReproducibleFileOrder, setVersion`

    - ### Methods inherited from class org.gradle.api.tasks.AbstractCopyTask

      `copy, createRootSpec, eachFile, eachFile, exclude, exclude, exclude, exclude, expand, filesMatching, filesMatching, filesNotMatching, filesNotMatching, filter, filter, filter, filter, from, from, from, getDirMode, getDuplicatesStrategy, getExcludes, getFileLookup, getFileMode, getFileResolver, getFileSystem, getFilteringCharset, getIncludeEmptyDirs, getIncludes, getInstantiator, getMainSpec, getRootSpec, getSource, include, include, include, include, isCaseSensitive, rename, rename, rename, rename, setCaseSensitive, setDirMode, setDuplicatesStrategy, setExcludes, setFileMode, setFilteringCharset, setIncludeEmptyDirs, setIncludes, with`

    - ### Methods inherited from class org.gradle.api.internal.ConventionTask

      `conventionMapping, conventionMapping, getConventionMapping`

    - ### Methods inherited from class org.gradle.api.internal.AbstractTask

      `addValidator, appendParallelSafeAction, compareTo, configure, deleteAllActions, dependsOn, dependsOnTaskDidWork, doFirst, doFirst, doLast, doLast, execute, finalizedBy, getActionClassLoaders, getActions, getAnt, getAsDynamicObject, getConvention, getDependsOn, getDescription, getDidWork, getEnabled, getExecuter, getExtensions, getFinalizedBy, getGroup, getIdentityPath, getImpliesSubProjects, getInputs, getLogger, getLogging, getMustRunAfter, getName, getOnlyIf, getOutputs, getPath, getProject, getServices, getShouldRunAfter, getStandardOutputCapture, getState, getTaskActions, getTaskDependencies, getTemporaryDir, getTemporaryDirFactory, getValidators, hasProperty, injectIntoNewInstance, isEnabled, isHasCustomActions, leftShift, mustRunAfter, onlyIf, onlyIf, prependParallelSafeAction, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setExecuter, setFinalizedBy, setGroup, setImpliesSubProjects, setMustRunAfter, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### WAR_EXTENSION

          public static final String WAR_EXTENSION

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### War

          public War()

  - ### Method Detail

    - #### getWebInf

          @Internal
          public CopySpec getWebInf()

    - #### webInf

          public CopySpec webInf(Closure configureClosure)

      Adds some content to the `WEB-INF` directory for this WAR archive.

      The given closure is executed to configure a `CopySpec`. The `CopySpec` is passed to the closure as its delegate.

      Parameters:
        `configureClosure` - The closure to execute
      Returns:
        The newly created `CopySpec`.

    - #### getClasspath

          @Optional
          @Classpath
          public FileCollection getClasspath()

      Returns the classpath to include in the WAR archive. Any JAR or ZIP files in this classpath are included in the `WEB-INF/lib` directory. Any directories in this classpath are included in the `WEB-INF/classes` directory.
      Returns:
        The classpath. Returns an empty collection when there is no classpath to include in the WAR.

    - #### setClasspath

          public void setClasspath(Object classpath)

      Sets the classpath to include in the WAR archive.
      Parameters:
        `classpath` - The classpath. Must not be null.

    - #### classpath

          public void classpath(Object... classpath)

      Adds files to the classpath to include in the WAR archive.
      Parameters:
        `classpath` - The files to add. These are evaluated as per `Project.files(Object...)`

    - #### getWebXml

          @InputFile
          @PathSensitive(value=NONE)
          @Optional
          public File getWebXml()

      Returns the `web.xml` file to include in the WAR archive. When `null`, no `web.xml` file is included in the WAR.
      Returns:
        The `web.xml` file.

    - #### setWebXml

          public void setWebXml(File webXml)

      Sets the `web.xml` file to include in the WAR archive. When `null`, no `web.xml` file is included in the WAR.
      Parameters:
        `webXml` - The `web.xml` file. Maybe null.